// StandardFieldsMessage.cc
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "Message.h"
#include "StandardFieldsMessage.h"

int32 StandardFieldsMessage:: toBuffer(char **buffer) const
{
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    nbytes += MPF::toBuffer(buffer,timeoutUnits);
    nbytes += MPF::toBuffer(buffer,timeout);
    nbytes += MPF::toBuffer(buffer,cmd);
    nbytes += MPF::toBuffer(buffer,status);
    nbytes += MPF::toBuffer(buffer,address);
    nbytes += MPF::toBuffer(buffer,extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&timeoutUnits);
    nbytes += MPF::fromBuffer(buffer,&timeout);
    nbytes += MPF::fromBuffer(buffer,&cmd);
    nbytes += MPF::fromBuffer(buffer,&status);
    nbytes += MPF::fromBuffer(buffer,&address);
    nbytes += MPF::fromBuffer(buffer,&extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&timeoutUnits);
    nbytes += MPF::fromBufferSwitch(buffer,&timeout);
    nbytes += MPF::fromBufferSwitch(buffer,&cmd);
    nbytes += MPF::fromBufferSwitch(buffer,&status);
    nbytes += MPF::fromBufferSwitch(buffer,&address);
    nbytes += MPF::fromBufferSwitch(buffer,&extra);
    return(nbytes);
}

static char *timeoutUnitsString[3] =
{"seconds","milliseconds","unknown"};

void StandardFieldsMessage:: print() const
{
    Message::print();
    int ind = (timeoutUnits<=1 ? timeoutUnits : 2);
    printf("timeout:%u %s ",timeout,timeoutUnitsString[ind]);
    printf("cmd:%u ",cmd);
    printf("status:%d ",status);
    printf("address:%d ",address);
    printf("extra:%d\n",cmd);
}
