// watchDogTest.cc
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include <semLib.h>
#include <tickLib.h>
#include <taskLib.h>

#include "WatchDog.h"

static void myCallback(void *pvt)
{
    printf("myCallback pvt %p\n",pvt);
}

int watchDogTest()
{
    WatchDog *pwatchDog = new WatchDog;
    printf("call start and see if callback occurs\n");
    pwatchDog->start(1,myCallback,0);
    taskDelay(120);
    printf("call start and cancel callback\n");
    pwatchDog->start(1,myCallback,0);
    taskDelay(2);
    pwatchDog->cancel();
    printf("call start and see if callback occurs\n");
    pwatchDog->start(1,myCallback,(void *)4);
    taskDelay(120);
    delete pwatchDog;
    return(0);
}

